Attribute VB_Name = "Registre"
' Dclarations des fonctions prsentes dans les DLL de Windows
' des constantes et types y affrant
'

'Registry Constants
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

'Registry Specific Access Rights
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_CREATE_LINK = &H20
Public Const KEY_ALL_ACCESS = &H3F

'Open/Create Options
Public Const REG_OPTION_NON_VOLATILE = 0&
Public Const REG_OPTION_VOLATILE = &H1

'Key creation/open disposition
Public Const REG_CREATED_NEW_KEY = &H1
Public Const REG_OPENED_EXISTING_KEY = &H2

'masks for the predefined standard access types
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const SPECIFIC_RIGHTS_ALL = &HFFFF

'Define severity codes
Public Const ERROR_SUCCESS = 0&
Public Const ERROR_NO_KEY = 2
Public Const ERROR_ACCESS_DENIED = 5
Public Const ERROR_NO_MORE_ITEMS = 259

'Predefined Value Types
Public Const REG_NONE = (0)                         'No value type
Public Const REG_SZ = (1)                           'Unicode nul terminated string
Public Const REG_EXPAND_SZ = (2)                    'Unicode nul terminated string w/enviornment var
Public Const REG_BINARY = (3)                       'Free form binary
Public Const REG_DWORD = (4)                        '32-bit number
Public Const REG_DWORD_LITTLE_ENDIAN = (4)          '32-bit number (same as REG_DWORD)
Public Const REG_DWORD_BIG_ENDIAN = (5)             '32-bit number
Public Const REG_LINK = (6)                         'Symbolic Link (unicode)
Public Const REG_MULTI_SZ = (7)                     'Multiple Unicode strings
Public Const REG_RESOURCE_LIST = (8)                'Resource list in the resource map
Public Const REG_FULL_RESOURCE_DESCRIPTOR = (9)     'Resource list in the hardware description
Public Const REG_RESOURCE_REQUIREMENTS_LIST = (10)

Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Boolean
End Type
Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type
Type ACL
        AclRevision As Byte
        Sbz1 As Byte
        AclSize As Integer
        AceCount As Integer
        Sbz2 As Integer
End Type
Type SECURITY_DESCRIPTOR
        Revision As Byte
        Sbz1 As Byte
        Control As Long
        Owner As Long
        Group As Long
        Sacl As ACL
        Dacl As ACL
End Type
Type WNDCLASS
    style As Long
    lpfnWndProc As Long
    cbClsExtra As Long
    cbWndExtra2 As Long
    hInstance As Long
    hIcon As Long
    hCursor As Long
    hbrBackground As Long
    lpszMenuName As String
    lpszClassName As String
End Type
Type WNDCLASSEX
    cbSize As Long
    style As Long
    lpfnWndProc As Long
    cbClsExtra As Long
    cbWndExtra As Long
    hInstance As Long
    hIcon As Long
    hCursor As Long
    hbrBackground As Long
    lpszMenuName As String
    lpszClassName As String
    hIconSm As Long
End Type

'
' Dclaration des fonctions et procdures
'

Declare Function RegConnectRegistry Lib "advapi32.dll" Alias "RegConnectRegistryA" (ByVal lpMachineName As String, ByVal hKey As Long, phkResult As Long) As Long

Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegFlushKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Declare Function RegGetKeySecurity Lib "advapi32.dll" (ByVal hKey As Long, ByVal SecurityInformation As Long, pSecurityDescriptor As SECURITY_DESCRIPTOR, lpcbSecurityDescriptor As Long) As Long

Declare Function RegisterClass Lib "user32" (Class As WNDCLASS) As Long
Declare Function RegisterClassEx Lib "user32" Alias "RegisterClassExA" (pcWndClassEx As WNDCLASSEX) As Integer

Declare Function RegisterClipboardFormat Lib "user32" Alias "RegisterClipboardFormatA" (ByVal lpString As String) As Long

Declare Function RegisterEventSource Lib "advapi32.dll" Alias "RegisterEventSourceA" (ByVal lpUNCServerName As String, ByVal lpSourceName As String) As Long
Declare Function RegisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal ID As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Declare Function RegisterServiceCtrlHandler Lib "advapi32.dll" Alias "RegisterServiceCtrlHandlerA" (ByVal lpServiceName As String, ByVal lpHandlerProc As Long) As Long
Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long

Declare Function RegLoadKey Lib "advapi32.dll" Alias "RegLoadKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpFile As String) As Long
Declare Function RegNotifyChangeKeyValue Lib "advapi32.dll" (ByVal hKey As Long, ByVal bWatchSubtree As Long, ByVal dwNotifyFilter As Long, ByVal hEvent As Long, ByVal fAsynchronus As Long) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias _
    "RegOpenKeyExA" (ByVal hKey As Long, _
    ByVal lpSubKey As String, ByVal ulOptions As Long, _
    ByVal samDesired As Long, phkResult As Long) As Long

Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftLastWriteTime As FILETIME) As Long
Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, lpcbValue As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" _
  (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
   ByRef lpType As Long, ByVal szData As String, ByRef lpcbData As Long) As Long

Declare Function RegReplaceKey Lib "advapi32.dll" Alias "RegReplaceKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpNewFile As String, ByVal lpOldFile As String) As Long
Declare Function RegRestoreKey Lib "advapi32.dll" Alias "RegRestoreKeyA" (ByVal hKey As Long, ByVal lpFile As String, ByVal dwFlags As Long) As Long
Declare Function RegSaveKey Lib "advapi32.dll" Alias "RegSaveKeyA" (ByVal hKey As Long, ByVal lpFile As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
Declare Function RegSetKeySecurity Lib "advapi32.dll" (ByVal hKey As Long, ByVal SecurityInformation As Long, pSecurityDescriptor As SECURITY_DESCRIPTOR) As Long
Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" _
  (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, _
   ByVal dwType As Long, ByVal szData As String, ByVal cbData As Long) As Long

Declare Function RegUnLoadKey Lib "advapi32.dll" Alias "RegUnLoadKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long




' Cre une nouvelle cl dans la base de registre
Public Sub CrationCl(Raine As Long, NomCl As String)
    Dim reponse As Long
    
    reponse = RegCreateKey(Raine, NomCl, 0)
    
End Sub
' Ouvre une cl dans la base de registre
Public Function OuvertureCl(Raine As Long, NomCl As String) As Long
    Dim reponse As Long, ReponseFinal As Long
    
    ' Ouverture
    reponse = RegOpenKeyEx(Raine, NomCl, 0, KEY_ALL_ACCESS, ReponseFinal)
    ' Vrification
    If reponse = ERROR_SUCCESS Then
        OuvertureCl = ReponseFinal
    End If
    
End Function
' Fermeture d'une cl dj ouverte auparavant
Public Sub FermetureCl(Cl As Long)
    Dim reponse As Long
    
    ' Ouverture
    reponse = RegCloseKey(Cl)
    
End Sub
' Vrifie la prsence d'une cl dans la base de registre
Public Function VrifiePrsenceCl(Raine As Long, NomCl As String) As Boolean
    Dim reponse As Long, Reponse2 As Long
    
    ' Ouverture
    reponse = RegOpenKeyEx(Raine, NomCl, 0, KEY_ALL_ACCESS, Reponse2)
    ' Vrification si cl prsente
    If reponse = ERROR_SUCCESS Then
        ' Fermeture de la cl
        FermetureCl Reponse2
        ' Valeur  renvoyer
        VrifiePrsenceCl = True
    Else
        ' Cl non-prsente
        VrifiePrsenceCl = False
    End If
    
End Function
' Cre d'une nouvelle entre dans la cl en spcifi
Public Sub CrationEntre(Cl As Long, Entre As String, Valeur As String)
    Dim reponse As Long
    
    ' Ajout d'un caractre vide
    Valeur = Valeur + Chr$(0)
    
    ' Appel de l'API
    reponse = RegSetValueEx(Cl, Entre, 0, 1, Valeur, Len(Valeur))
    
End Sub
' Ecrit une valeur dans une entre dans la cl en spcifi
Public Sub EcritEntre(Cl As Long, Entre As String, Valeur As String)
    Dim reponse As Long
    
    ' Ajout d'un caractre vide
    Valeur = Valeur + Chr$(0)
    
    ' Appel de l'API
    reponse = RegSetValueEx(Cl, Entre, 0, 1, Valeur, Len(Valeur))
    
End Sub
' Lire d'une entre dans la cl en spcifi
Public Function LectureEntre(Cl As Long, Entre As String) As String
    Dim LeBuffer As String
    Dim LaLongueur As Long
    Dim reponse As Long
    
    ' Vidage des paramtres
    LeBuffer = Space$(2550)
    LaLongueur = Len(LeBuffer)
    ' Appel de l'API
    reponse = RegQueryValueEx(Cl, Entre, 0, 1, LeBuffer, LaLongueur)
    
    ' Vrification
    LeBuffer = Left$(LeBuffer, LaLongueur)
    If Right$(LeBuffer, 1) = Chr$(0) Then
        LeBuffer = Left$(LeBuffer, Len(LeBuffer) - 1)
    End If
    
    ' Fin
    LectureEntre = Trim$(LeBuffer)
    
End Function
' Lire d'une entre dans la cl spcifi
Public Function LectureEntreCl(Raine As Long, NomCl As String, Entre As String) As String
    Dim Cl As Long
    Dim LeBuffer As String
    Dim LaLongueur As Long
    Dim reponse As Long
    
    ' Ouverture de la cl
    Cl = OuvertureCl(Raine, NomCl)
    
    ' Vidage des paramtres
    LeBuffer = Space$(2550)
    LaLongueur = Len(LeBuffer)
    ' Appel de l'API
    reponse = RegQueryValueEx(Cl, Entre, 0, 1, LeBuffer, LaLongueur)
    
    ' Fermeture de la cl
    FermetureCl Cl
    
    ' Vrification
    LeBuffer = Left$(LeBuffer, LaLongueur)
    If Right$(LeBuffer, 1) = Chr$(0) Then
        LeBuffer = Left$(LeBuffer, Len(LeBuffer) - 1)
    End If
    
    ' Fin
    LectureEntreCl = Trim$(LeBuffer)
    
End Function
' Supprimer une cl
Public Sub SupprimerCl(Raine As Long, NomCl As String)
    Dim Rsultat As Long

    Rsultat = RegDeleteKey(Raine, NomCl)

End Sub
' Supprimer une entre dans une cl
Public Sub SupprimerEntre(Cl As Long, Entre As String)
    Dim Rsultat As Long

    Rsultat = RegDeleteValue(Cl, Entre)

End Sub
' Convertion de la chane
Public Function ConvertString(tmpVal As String, KeyValSize As Long) As String
    
    ' Vrification de la terminaison
    If (Asc(Mid$(tmpVal, KeyValSize, 1)) = 0) Then
        ' Win95 ajoute un 0 terminal
        ConvertString = Left$(tmpVal, KeyValSize - 1)
    Else
        ' WinNT n'ajoute pas de zro terminal
        ConvertString = Left$(tmpVal, KeyValSize)
    End If
    
End Function
